import { ClientAdapter, Request, RequestInterceptor, Response, ResponseInterceptor } from '../auth-toolbox';
import { AxiosInstance, AxiosRequestConfig, AxiosResponse } from 'axios';
/**
 * Wraps instance of Axios client into a {@link ClientAdapter} to support automated authentication.
 *
 * It should be given to {@link Auth} constructor.
 */
export declare class AxiosAdapter implements ClientAdapter<AxiosResponse> {
    private axios;
    private config;
    constructor(axios: AxiosInstance, config?: AxiosRequestConfig);
    login(request: Request): Promise<AxiosResponse>;
    logout(request: Request): Promise<AxiosResponse>;
    renew(request: Request): Promise<AxiosResponse>;
    request(request: Request): Promise<AxiosResponse>;
    asResponse(response: AxiosResponse): Response;
    asRequest(request: AxiosRequestConfig): Request;
    setupRequestInterceptor(interceptor: RequestInterceptor): () => void;
    setupErrorResponseInterceptor(interceptor: ResponseInterceptor): () => void;
}
