var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/**
 * Wraps instance of Axios client into a {@link ClientAdapter} to support automated authentication.
 *
 * It should be given to {@link Auth} constructor.
 */
var AxiosAdapter = /** @class */ (function () {
    function AxiosAdapter(axios, config) {
        if (config === void 0) { config = {}; }
        this.axios = axios;
        this.config = config;
    }
    AxiosAdapter.prototype.login = function (request) {
        return this.axios.request(__assign(__assign({}, this.config), request));
    };
    AxiosAdapter.prototype.logout = function (request) {
        return this.axios.request(__assign(__assign({}, this.config), request));
    };
    AxiosAdapter.prototype.renew = function (request) {
        return this.axios.request(__assign(__assign({}, this.config), request));
    };
    AxiosAdapter.prototype.request = function (request) {
        return this.axios.request(__assign({}, request));
    };
    AxiosAdapter.prototype.asResponse = function (response) {
        var r = {};
        if (response.data) {
            r.data = response.data;
        }
        if (response.headers) {
            r.headers = response.headers;
        }
        if (response.status) {
            r.status = response.status;
        }
        return r;
    };
    AxiosAdapter.prototype.asRequest = function (request) {
        var url = request.url;
        var method = request.method;
        if (!url)
            throw new Error('No url is defined');
        if (!method)
            throw new Error('No method is defined');
        var r = { url: url, method: method };
        if (request.data) {
            r.data = request.data;
        }
        if (request.headers) {
            r.headers = request.headers;
        }
        return r;
    };
    AxiosAdapter.prototype.setupRequestInterceptor = function (interceptor) {
        var _this = this;
        var id = this.axios.interceptors.request.use(function (config) { return __awaiter(_this, void 0, void 0, function () {
            var request, intercepted;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        request = this.asRequest(config);
                        return [4 /*yield*/, interceptor.interceptRequest(request)];
                    case 1:
                        intercepted = _a.sent();
                        if (intercepted) {
                            config.data = request.data;
                            config.headers = request.headers;
                        }
                        return [2 /*return*/, config];
                }
            });
        }); });
        return function () { return _this.axios.interceptors.request.eject(id); };
    };
    AxiosAdapter.prototype.setupErrorResponseInterceptor = function (interceptor) {
        var _this = this;
        var id = this.axios.interceptors.response.use(function (response) { return response; }, function (error) { return __awaiter(_this, void 0, void 0, function () {
            var request, response, intercepted;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!error.response) return [3 /*break*/, 2];
                        request = this.asRequest(error.config);
                        response = this.asResponse(error.response);
                        return [4 /*yield*/, interceptor.interceptResponse(request, response)];
                    case 1:
                        intercepted = _a.sent();
                        if (intercepted) {
                            delete error.config.baseURL; // Workaround
                            return [2 /*return*/, this.axios.request(error.config)];
                        }
                        _a.label = 2;
                    case 2: throw error;
                }
            });
        }); });
        return function () { return _this.axios.interceptors.response.eject(id); };
    };
    return AxiosAdapter;
}());
export { AxiosAdapter };
//# sourceMappingURL=axios-adapter.js.map