import { Token, TokenDecoder } from '../auth-toolbox';
/**
 * Default implementation of {@link TokenDecoder}. It doesn't support decoding {@link Token} and checks the
 * expiration date from the server response.
 *
 * It's the default value on {@link Auth} constructor for {@link AuthOptions.accessTokenDecoder}.
 */
export declare class DefaultTokenDecoder implements TokenDecoder {
    protected offset: number;
    constructor(offsetSeconds?: number);
    isExpired(token: Token): boolean;
}
