import { Tokens, TokenStorage } from '../auth-toolbox';
/**
 * Default implementation of {@link TokenStorage}, delegating to Storage of the browser.
 * (`sessionStorage` or `localStorage`).
 *
 * It should be given to {@link Auth} constructor through {@link AuthOptions.tokenStorage} and
 * {@link AuthOptions.persistentTokenStorage}.
 */
export declare class DefaultTokenStorage implements TokenStorage {
    readonly async: false;
    private storage;
    private accessTokenStorageKey;
    private refreshTokenStorageKey;
    private expiresAtSuffix;
    private credentialsTokenStorageKey;
    constructor(storage: Storage, accessTokenStorageKey?: string, refreshTokenStorageKey?: string, expiresAtSuffix?: string, credentialsTokenStorageKey?: string);
    store<C>(tokens: Tokens<C>): any;
    clear(): any;
    getTokens<C>(): Tokens<C> | undefined;
}
